Geological layer generator for Minetest "rocks" {wip}
=============

Aim of this mod is to replace all generic stone (default:stone) and 
generate underground layers of different rocks.

Features
--------

* layers of different rocks: sort of working
* ore veins: being added
* extensibility, api: changed million times

** Work in progress! **

* git clone git://repo.or.cz/rocks.git ([show](http://repo.or.cz/rocks.git/))
* (old) Git clone: [https](https://gitorious.org/mt/rocks.git)
* Forum [post](https://forum.minetest.net/viewtopic.php?f=9&t=11779)

This mod nor minetest_game/default do not define meaningful biomes. 
So if you do not want unlimited grassland I suggest installing the 
[Paramat's biomesdev mod](https://github.com/paramat/biomesdev) and adding 
"rocks?" to depends.txt file inside the biomesdev folder. This is needed, 
becouse "rocks" overrides the standard biome registration callback to patch 
in it's own sedimentary rocks.

Screenshots
-----------

all were out of date

License
-------

* My Code: GNU General Public License v2 or higher.
* Media: see txt files in the texture folder
* stated in the corresponding file

Documentation
-------------

How the underground is generated: *todo*.

Mod has been rewritten, so no doc yet.

The sedimentary layer
-------------

Is implemented by modifiing MGv7 biomes to use rocks's sedimentary rocks. 
This means that you need mapgen v7 enabled. I also suggest enabling caves 
and dungeons, as they are cool. 

Soil is normlly 50-70 cm deep in real life, so I made soil (dirt) only 1 
block thick. Under this thin layer of dirt an sedimentary layer is located. 
In RL, there is clay and other stuff.

There are various types of sedimentary rock. They are generated according 
to 2D noises described below.

types = Clastic, Biochemical,  Chemical, Vulcano/Other

| X      | tp2<0.76     | tp2>0.7 |
|--------|--------------|--------|
| tp1<0.2 |   Clastic    |  Chemical |
| tp1>0.2 | BioChemical  |  Vu/Ot |

- Noise_tp1( 50)= type1
- Noise_tp2( 70)= type2
- Noise_vc(100)= particle size
- Noise_sp(220)= pressue/ hardness

I. 2D: fast, acceptable imho <-(used)
II. 3D: nice

### Clastic sediments

Made from large or small particles. Either loose or bound into stones.

(particle size: top-large botom-small)

(hargness: loose -> solid)

1. gravel -> conglomerate
2. sand -> sandstone
3. mudstone
4. clay -> claystone -> slate

### BioChemical sediments

Made from acient plants and creatures that died long ago and turned into rock.

Noise_vs: kind of sediment: (top) oil, Limestone, other, carbon-based

Noise_sp: low quality -> high quality

1. oil: ?
2. Limestone
3. other: fosfates, silicates, hornfels (unimp)
4. carbon-based: Lignite -> Coal -> Anthracite

### Chemical sediments

Created by chemical or physics/chemical reactions.

- Evaporites (unimp)

### Vulanic and extraterrestrial sediments

???

The Igenous layer
--------------

Default stone is aliased to basalt, but for some reason the alias is not 
working so please treat stone as basalt until I find way to fix it.

Everything below sedimentary and (unimp) metamorphic layer is of igneous origin. Primary rock is basalt. But about half of basalt is replaced by granite. Some smaller fraction (like 20%) is then replaced by diorite and gabbro.
These are the primary rocks, and more should come.

### Mineral distribution

Mineral ore is placed only in nodes of correct rock and only if the region 
for the ore is right. These "mineral biomes" can and do overlap and change 
every like 100 nodes. Following regions are defined:

| Region  | minerals
|---------|----------
| Copper  | Chalcopyrite, Malachyte
| Pb/Zn   | Sphalerite, Galena
| Iron    | Magnetite

### Skarn deposits

Are larg-ish (15-20m) blobs of skarn stone. They spawn only in granite and 
limestone. Copper, Lead, Zinc and Iron ores often enrich the skarn stone. 
Some deposits may (unimp) contain considerable amounts of Molybenium, 
Uranium and Wolfram ores.

Concentration of the minerals is quite high, as to regard the player for 
finding a not-so-common skarn vein.

### Pegmatite veis

Spawn only in granite. Are bit larger than skarn veins. Contain minerals 
like skarn and more exotic minerals.
